# Fibo 2.0 Edit API

> Instruktionsbasierter Editor für 1 bis 4 Bilder mit optionaler Maske für regionale Bearbeitungen eines einzelnen Bildes

Bearbeitet ein bis vier in `image_urls` angegebene Bilder; die `instruction` verweist auf sie als <image_1>, <image_2> und so weiter. Geeignet für Hintergrundwechsel und neue Produktinszenierungen. Eine `mask_url` beschränkt die Bearbeitung bei Einzelbildanfragen auf eine Region. `aspect_ratio` bietet 16 aufgelistete Werte, und ein strukturiertes `vgl`-Dokument kann übergeben oder wiederverwendet werden.

- Model id: `bria/fibo-2/edit`
- Made by: Bria AI
- Category: Image Editing
- Output: image
- Price: $0.04 / image (cheapest run $0.04 (40 API credits))
- Run: `POST https://api.doitong.ru/v1/run/bria/fibo-2/edit`
- Quote: `POST https://api.doitong.ru/v1/quote/bria/fibo-2/edit`
- Docs page: https://doitong.com/de/developers/models/bria/fibo-2/edit

## Pricing

Price: **$0.04 / image**. Billed per generated image.

The full example input below costs $0.04 = 40 API credits (1 image × 40 API credits).

Prices are the upstream price in USD, paid from the API balance in API credits (1000 API credits = 1 USD). `POST https://api.doitong.ru/v1/quote/bria/fibo-2/edit` with the same JSON body returns the exact price for that input; the quote is exactly what a run charges. Invalid input is never charged and failed or canceled requests are refunded automatically.

## Input parameters

Send either the canonical name or the native field name (not both). Canonical names are the same across models.

| Parameter | Canonical name | Type | Required | Default | Allowed values / range | Description |
|---|---|---|---|---|---|---|
| `image_urls` | `images` | array of image URL | yes |  | 1 – 4 items | Bearbeitungseingaben, die nach Einreichungsreihenfolge als <image_1>, <image_2> usw. für die Verwendung in der Anweisung indiziert sind. Gib 1–4 Bilder als Dateien oder URLs an. |
| `instruction` |  | string \| null | no |  |  | Bearbeitungsanweisungen, die 'vgl' ändern, wenn es zusammen damit angegeben wird. Andernfalls wird die frei formulierte Anfrage in ein VGL-Dokument erweitert und in die Antwort aufgenommen. |
| `aspect_ratio` |  | enum (string) \| null | no |  | `1:1`, `1:2`, `1:3`, `1:4`, `1:5`, `2:1`, `2:3`, `3:1`, `3:2`, `3:4`, `4:1`, `4:3`, `4:5`, `5:1`, `5:4`, `9:16`, `9:21`, `10:16`, `16:9`, `16:10`, `21:9` | Seitenverhältnis für eine Ausgabe von ungefähr einem Megapixel; ein einzelnes Eingabebild behält unabhängig von dieser Einstellung sein Verhältnis bei. Bei mehreren Eingaben wird bei Weglassen der Einstellung das Verhältnis des ersten Bildes verwendet. |
| `seed` |  | integer | no | `5555` | 0 – 2,147,483,647 | Seed zur Steuerung der Zufälligkeit für reproduzierbare Ergebnisse im Bereich von 0 bis 2147483647. |
| `mask_url` | `mask` | string (image URL) \| null | no |  |  | Bearbeitungsmaske für Anfragen mit einem einzelnen Bild, als Datei oder URL mit zu diesem Bild passenden Abmessungen bereitgestellt. Weiß markiert Bereiche für die Neugenerierung, Schwarz alles andere. Das Ergebnis verwendet die Abmessungen der Eingabe und behält außerhalb der Maske deren Pixel bei. |
| `vgl` |  | object {short_description, objects, background_setting, lighting, aesthetics, photographic_characteristics, style_medium, text_render, context, artistic_style, edit_instruction} \| null | no |  |  | VGL-Dokument (Visual Generation Language), das aus einer früheren Antwort wiederverwendet werden kann. Zusammen mit 'instruction' stellt es das erste Bild dar und dient als Grundlage für die Bearbeitung; ohne 'instruction' legt es die unveränderte Bearbeitung fest und muss 'edit_instruction' enthalten. |
| `vgl.short_description` |  | string \| null | no |  |  | Kurze Beschreibung des vorgesehenen Ausgabebildes. |
| `vgl.objects` |  | array of object {description, location, relationship, relative_size, shape_and_color, texture, appearance_details, number_of_objects, pose, expression, clothing, action, gender, skin_tone_and_texture, orientation} \| null | no | `[]` |  | Gib den Inhalt des erzeugten Bildes als Liste an und erfasse die Attribute jedes Objekts sowie seine Beziehungen zu den anderen dargestellten Objekten. |
| `vgl.objects[].description` |  | string \| null | no |  |  | Beschreibung des vorgesehenen Ausgabeobjekts. |
| `vgl.objects[].location` |  | string \| null | no |  |  | Position des Objekts innerhalb des Bildes. |
| `vgl.objects[].relationship` |  | string | yes |  |  | Beziehung des Objekts zu den anderen Objekten des Bildes. |
| `vgl.objects[].relative_size` |  | string \| null | no |  |  | Größe des Objekts relativ zum Bild. |
| `vgl.objects[].shape_and_color` |  | string \| null | no |  |  | Form und Farbe des Objekts. |
| `vgl.objects[].texture` |  | string \| null | no |  |  | Textur des Objekts. |
| `vgl.objects[].appearance_details` |  | string \| null | no |  |  | Details zum Erscheinungsbild des Objekts. |
| `vgl.objects[].number_of_objects` |  | integer \| null | no |  |  | Anzahl der Objekte im Bild. |
| `vgl.objects[].pose` |  | string \| null | no |  |  | Pose des dargestellten Objekts. |
| `vgl.objects[].expression` |  | string \| null | no |  |  | Ausdruck des dargestellten Objekts. |
| `vgl.objects[].clothing` |  | string \| null | no |  |  | Vom dargestellten Objekt getragene Kleidung. |
| `vgl.objects[].action` |  | string \| null | no |  |  | Vom dargestellten Objekt ausgeführte Handlung. |
| `vgl.objects[].gender` |  | string \| null | no |  |  | Geschlecht des dargestellten Objekts. |
| `vgl.objects[].skin_tone_and_texture` |  | string \| null | no |  |  | Hauttextur und -ton des dargestellten Objekts. |
| `vgl.objects[].orientation` |  | string \| null | no |  |  | Ausrichtung des dargestellten Objekts. |
| `vgl.background_setting` |  | string \| null | no |  |  | Hintergrundszenerie für das erzeugte Bild. |
| `vgl.lighting` |  | object {conditions, direction, shadows} \| null | no |  |  | Beleuchtung für das erzeugte Bild. |
| `vgl.lighting.conditions` |  | string \| null | no |  |  | Beleuchtungsbedingungen für das erzeugte Bild. |
| `vgl.lighting.direction` |  | string \| null | no |  |  | Beleuchtungsrichtung für das erzeugte Bild. |
| `vgl.lighting.shadows` |  | string \| null | no |  |  | Im erzeugten Bild darzustellende Schatten. |
| `vgl.aesthetics` |  | object {composition, color_scheme, mood_atmosphere} \| null | no |  |  | Ästhetische Eigenschaften für das erzeugte Bild. |
| `vgl.aesthetics.composition` |  | string \| null | no |  |  | Komposition für das erzeugte Bild. |
| `vgl.aesthetics.color_scheme` |  | string \| null | no |  |  | Farbpalette für das erzeugte Bild. |
| `vgl.aesthetics.mood_atmosphere` |  | string \| null | no |  |  | Stimmung und Atmosphäre für das erzeugte Bild. |
| `vgl.photographic_characteristics` |  | object {depth_of_field, focus, camera_angle, lens_focal_length} \| null | no |  |  | Fotografische Eigenschaften für das erzeugte Bild. |
| `vgl.photographic_characteristics.depth_of_field` |  | string \| null | no |  |  | Schärfentiefe für das erzeugte Bild. |
| `vgl.photographic_characteristics.focus` |  | string \| null | no |  |  | Fokus für das erzeugte Bild. |
| `vgl.photographic_characteristics.camera_angle` |  | string \| null | no |  |  | Kamerawinkel für das erzeugte Bild. |
| `vgl.photographic_characteristics.lens_focal_length` |  | string \| null | no |  |  | Objektiveinstellung für das erzeugte Bild, angegeben als Brennweite. |
| `vgl.style_medium` |  | string \| null | no |  |  | Stilistisches Medium für das erzeugte Bild. |
| `vgl.text_render` |  | array of object {text, location, size, color, font, appearance_details} \| null | no | `[]` |  | Liste der Textelemente, die in das Bild aufgenommen werden sollen. |
| `vgl.text_render[].text` |  | string | yes |  |  | Zu rendernder Text, der fibo-2 zusätzlich visuell als Bild präsentiert wird, damit der angegebene Wortlaut exakt reproduziert werden kann. |
| `vgl.text_render[].location` |  | string \| null | no |  |  | Textplatzierung innerhalb des Bildes. |
| `vgl.text_render[].size` |  | string \| null | no |  |  | Textgröße innerhalb des Bildes. |
| `vgl.text_render[].color` |  | string \| null | no |  |  | Für den Text verwendete Farbe. |
| `vgl.text_render[].font` |  | string \| null | no |  |  | Schriftstil des Textes. |
| `vgl.text_render[].appearance_details` |  | string \| null | no |  |  | Zusätzliche bemerkenswerte Details zum Erscheinungsbild des Textes. |
| `vgl.context` |  | string \| null | no |  |  | Kontext für das erzeugte Bild. |
| `vgl.artistic_style` |  | string \| null | no |  |  | Künstlerischer Stil für das erzeugte Bild. |
| `vgl.edit_instruction` |  | string \| null | no |  |  | Anweisung zur Bearbeitung des Bildes. |

File parameters (`images`, `mask`) take a public `https://` URL, a `data:` URI up to 10 MB, or the `file_url` of an upload from `POST /files`.

## Example input

Required parameters only:

```json
{
  "images": [
    "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg"
  ]
}
```

A fuller example:

```json
{
  "image_urls": [
    "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg"
  ]
}
```

## Run it

Set `DOITONG_API_KEY` to a key from https://doitong.com/developers/dashboard#keys. `?wait=20` returns the finished request in the same call when it is ready within 20 seconds; otherwise poll `GET /requests/{id}` (it also accepts `?wait=`), or pass `webhook_url`.

### curl

```bash
# Run the model; wait up to 20 s for the finished result in the same call
curl -X POST "https://api.doitong.ru/v1/run/bria/fibo-2/edit?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY" \
  -H "Content-Type: application/json" \
  -d '{
    "image_urls": [
      "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg"
    ]
  }'

# Still "queued" or "running"? Poll with the id from the response:
curl "https://api.doitong.ru/v1/requests/REQUEST_ID?wait=20" \
  -H "Authorization: Bearer $DOITONG_API_KEY"
```

### JavaScript

```javascript
const API = "https://api.doitong.ru/v1";
const headers = {
  "Authorization": "Bearer " + process.env.DOITONG_API_KEY,
  "Content-Type": "application/json",
};

// Run the model; wait up to 20 s for the finished result in the same call
let res = await fetch(API + "/run/bria/fibo-2/edit?wait=20", {
  method: "POST",
  headers,
  body: JSON.stringify({
    "image_urls": [
      "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg"
    ]
  }),
});
let request = await res.json();
if (!res.ok) throw new Error(request.error.code + ": " + request.error.message);

// Not finished yet: long-poll until it is
while (request.status === "queued" || request.status === "running") {
  res = await fetch(API + "/requests/" + request.id + "?wait=20", { headers });
  request = await res.json();
}
if (request.status !== "succeeded") throw new Error(JSON.stringify(request.error));
console.log(request.outputs.map((o) => o.url), request.cost.credits + " API credits ($" + request.cost.usd + ")");
```

### Python

```python
import os
import requests

API = "https://api.doitong.ru/v1"
headers = {"Authorization": "Bearer " + os.environ["DOITONG_API_KEY"]}

payload = {
    "image_urls": [
        "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg",
    ],
}

# Run the model; wait up to 20 s for the finished result in the same call
r = requests.post(API + "/run/bria/fibo-2/edit", params={"wait": 20}, json=payload, headers=headers)
request = r.json()
if not r.ok:
    raise RuntimeError(request["error"]["code"] + ": " + request["error"]["message"])

# Not finished yet: long-poll until it is
while request["status"] in ("queued", "running"):
    request = requests.get(API + "/requests/" + request["id"], params={"wait": 20}, headers=headers).json()
if request["status"] != "succeeded":
    raise RuntimeError(request["error"])
print([o["url"] for o in request["outputs"]], request["cost"]["credits"], "API credits", "$" + request["cost"]["usd"])
```

### MCP

The MCP server at `https://api.doitong.ru/v1/mcp` exposes the tools `search_models`, `get_model`, `quote`, `run`, `get_request`, `cancel_request`, `list_requests`, `create_upload` and `get_account`. A `run` call for this model:

```json
{
  "jsonrpc": "2.0",
  "id": 1,
  "method": "tools/call",
  "params": {
    "name": "run",
    "arguments": {
      "model_id": "bria/fibo-2/edit",
      "input": {
        "image_urls": [
          "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg"
        ]
      },
      "wait_seconds": 20
    }
  }
}
```

## Response

Every call returns a request object. `status` is one of `queued`, `running`, `succeeded`, `failed`, `canceled`. `outputs` lists the generated files with URLs on our storage (kept forever, or 7 days with `?storage=temporary`; `storage` says which); `output` is the model's own result object with the same URLs.

```json
{
  "id": "req_8k2m4q7x1z9c3v5b6n0p2r4t",
  "object": "request",
  "model": "bria/fibo-2/edit",
  "status": "succeeded",
  "created_at": "2026-10-20T12:00:00Z",
  "started_at": "2026-10-20T12:00:02Z",
  "completed_at": "2026-10-20T12:00:09Z",
  "queue_position": null,
  "cost": {
    "credits": 40,
    "usd": "0.04",
    "charged": 40,
    "refunded": 0
  },
  "input": {
    "image_urls": [
      "https://content.doitong.com/images/showcase/v3/gen_fox_cartoon.jpg"
    ]
  },
  "output": {
    "image": {
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
      "content_type": "image/jpeg",
      "file_name": "0-output.jpeg",
      "file_size": 1843200,
      "width": 1024,
      "height": 768
    },
    "images": [
      {
        "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
        "content_type": "image/jpeg",
        "file_name": "0-output.jpeg",
        "file_size": 1843200,
        "width": 1024,
        "height": 768
      }
    ],
    "vgl": {}
  },
  "outputs": [
    {
      "type": "image",
      "url": "https://content.doitong.com/dev-api/2026/10/20/req_8k2m4q7x1z9c3v5b6n0p2r4t/0-output.jpeg",
      "content_type": "image/jpeg",
      "file_size": 1843200,
      "width": 1024,
      "height": 768,
      "stored": true
    }
  ],
  "error": null,
  "metrics": {
    "inference_seconds": 6.8
  },
  "urls": {
    "self": "https://api.doitong.ru/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t",
    "cancel": "https://api.doitong.ru/v1/requests/req_8k2m4q7x1z9c3v5b6n0p2r4t/cancel"
  }
}
```

### Output fields (`output`)

| Field | Type | Description |
|---|---|---|
| `image` | object {url, content_type, file_name, file_size, width, height} | Aus der Bearbeitung resultierendes Bild. |
| `images` | array of object {url, content_type, file_name, file_size, width, height} | Bildliste im Format, das von anderen FIBO-Apps zurückgegeben wird; ihr einziger Eintrag ist dasselbe Bild. |
| `vgl` | object | Für die Bearbeitung verwendetes VGL mit eingeschlossenem `edit_instruction`. |

## Related models

- [Fibo 2.0 Generate](https://doitong.com/developers/models/bria/fibo-2/generate.md) (`bria/fibo-2/generate`): $0.04 / image
- [FLUX.1 Kontext \[pro\]](https://doitong.com/developers/models/flux-pro/kontext.md) (`flux-pro/kontext`): $0.04 / image
- [GPT Image 2.5 Edit](https://doitong.com/developers/models/openai/gpt-image-2.5/flare/edit.md) (`openai/gpt-image-2.5/flare/edit`): from $0.12 / image
- [Nano Banana 2 Edit](https://doitong.com/developers/models/nano-banana-2/edit.md) (`nano-banana-2/edit`): from $0.06 / image
- [Nano Banana Pro Edit](https://doitong.com/developers/models/nano-banana-pro/edit.md) (`nano-banana-pro/edit`): from $0.15 / image
- [Qwen Image 3 Edit](https://doitong.com/developers/models/alibaba/qwen-image-3/edit.md) (`alibaba/qwen-image-3/edit`): from $0.04 / image
- [Seedream 5.0 Pro Edit](https://doitong.com/developers/models/bytedance/seedream/v5/pro/edit.md) (`bytedance/seedream/v5/pro/edit`): from $0.0675 / run of output image
- [Bria](https://doitong.com/developers/models/bria/reimagine.md) (`bria/reimagine`): $0.04 / image

## Links

- HTML page: https://doitong.com/developers/models/bria/fibo-2/edit
- All models and guides for AI agents: https://doitong.com/developers/llms.txt
- OpenAPI 3.1 with this model's typed request body: https://doitong.com/developers/openapi.json?model=bria/fibo-2/edit
- Errors: https://doitong.com/developers/docs/errors
- Model details as JSON: https://api.doitong.ru/v1/models/bria/fibo-2/edit
